/*
 Esplora TFT Bitmap Logos
 Programma per testare la lettura di immagini
 da SD
 By Adriano Gandolfo www.adrirobot.it
 */

// include le necessarie librerie
#include <Esplora.h>
#include <SPI.h>
#include <SD.h>
#include <TFT.h>

// si definisce il pin ESPLORA collegato alla linea di
// selezione del circuito integrato per scheda SD
#define SD_CS    8

// questa variabile rappresenta l'immagine da disegnare sullo schermo
PImage slide;
String numero;
void setup() {
  // inizializzazione dello schermo e messsaggio iniziale
  EsploraTFT.begin();
  EsploraTFT.background(0, 0, 0);
  EsploraTFT.setTextSize(1);
  EsploraTFT.stroke(0,255,0); //colore del testo verde
  EsploraTFT.text("Arduino Esplora",0,0);
  EsploraTFT.stroke(255,255,0); //colore del testo giallo
  EsploraTFT.text("Test SD - LCD Bitmap",0,16);
  EsploraTFT.setTextSize(1);
  // Tentare di accedere alla scheda SD. Se non funziona (ad esempio
  // Nessuna scheda presente), il LED di ESPLORA diventa rosso.
  EsploraTFT.text("Inizializzazione SD card",0,32);
  if (!SD.begin(SD_CS)) {
    EsploraTFT.stroke(255,0,0); //colore del testo rosso
    EsploraTFT.text("Fallita!",0,45);
    Esplora.writeRed(255);
    return;
  }
  EsploraTFT.stroke(0,255,0); //colore del testo verde
  EsploraTFT.text("OK !",0,45);
  EsploraTFT.stroke(255,0,255); //colore del testo magenta
  EsploraTFT.text("Premere il tasto S1",0,65);

  //Routine attesa pressione tasto S1
  int S1;  // holds values of switches 1 to 3
  S1=HIGH; 
  while(S1==HIGH ) { 
    S1 = Esplora.readButton(SWITCH_1);

    if(S1==LOW) 
      demo();  // se si preme il tasto viene avviata le demo
  }
}
// Ora si accederà alla scheda SD, se il caricamento non
// andrà a buon fine si accenderà il led rosso
void demo()
{
  Esplora.writeRGB(0, 0, 0);
  for (int i=1; i <10; i++)
  { 
    Esplora.writeRGB(0, 0, 0);
    numero = String (i);
    String immagine = String (numero + ".bmp");
    char immagine_array[6];
    immagine.toCharArray (immagine_array, sizeof(immagine_array));
    slide = EsploraTFT.loadImage(immagine_array);
    if (slide.isValid()) {
      Esplora.writeGreen(255);
    }
    else
      Esplora.writeRed(255);
    EsploraTFT.image(slide, 0, 0);
    //tempo di attesa per nuova immagine
    delay(1000);
  }
  EsploraTFT.background(0, 0, 0);
  EsploraTFT.setTextSize(2);
  EsploraTFT.stroke(0,255,0); //colore del testo verde
  EsploraTFT.text("Test completo!",0,0);
}
void loop()
{
}
